<script setup>
import { toRef, watch } from 'vue';
import { useField } from 'vee-validate';
import { BFormCheckbox } from 'bootstrap-vue';
const props = defineProps({
  type: {
    type: String,
    default: 'text',
  },
  value: {
    type: [String, Number, Boolean],
    default: undefined,
  },

  disabled: {
    type: Boolean,
    default: null,
  },
  autofocus: {
    type: Boolean,
    default: false,
  },
  name: {
    type: String,
    required: true,
  },
  maxlength: {
    type: String,
    default: 1000000,
  },
  label: {
    type: String,
    required: true,
  },
  innerLabel: {
    type: String,
    default: '',
  },
  successMessage: {
    type: String,
    default: '',
  },
  placeholder: {
    type: String,
    default: '',
  },
  class: {
    type: String,
    default: '',
  },
  isSwitch: {
    type: Boolean,
    default: true,
  },
});

// use `toRef` to create reactive references to `name` prop which is passed to `useField`
// this is important because vee-validte needs to know if the field name changes
// https://vee-validate.logaretm.com/v4/guide/composition-api/caveats
const name = toRef(props, 'name');
const value = toRef(props, 'value');

watch([value], () => {
  if (value.value) {
    setValue(value.value);
  } else {
    resetField({
      value: false,
      touched: false,
      errors: []
    })
  }
})

// we don't provide any rules here because we are using form-level validation
// https://vee-validate.logaretm.com/v4/guide/validation#form-level-validation
const {
  value: inputValue,
  errorMessage,
  handleBlur,
  handleChange,
  setState,
  resetField,
  setValue,
  meta,
} = useField(name, undefined, {
  initialValue: props.value,
});

const emit = defineEmits(['change'])
function changed(params) {
    emit('change', params)
}

</script>

<template :class="{ 'has-error': !!errorMessage, success: meta.valid }">
           <label class="d-block pt-1 mr-1" for="status" v-if="label"
              >{{ label }} <span class="text-danger">*</span></label
            >
            <template v-if="isSwitch">
              <b-form-checkbox
              :class="class"
              :checked="value"
              switch
              @input="handleChange"
              @blur="handleBlur"
              :state="errorMessage ? false : null"
              :name="name"
              :id="name"
              :type="type"
              :placeholder="placeholder"
              :disabled="disabled"
              @change="changed"
              
              />
            <small class="text-danger" v-if="errorMessage">{{ errorMessage }}</small>
            </template>
            
            <template v-if="!isSwitch">
              <b-form-checkbox
              :class="class"
              :checked="value"
              @input="handleChange"
              @blur="handleBlur"
              :state="errorMessage ? false : null"
              :name="name"
              :id="name"
              :type="type"
              :placeholder="placeholder"
              :disabled="disabled"
              @change="changed"
              >
              {{ innerLabel }}
              </b-form-checkbox>
            <small class="text-danger" v-if="errorMessage">{{ errorMessage }}</small>
            </template>
</template>

<style scoped>

</style>
